// Load the Visualization API and the controls package.
google.charts.load('current', {'packages': ['table']});

// Set a callback to run when the Google Visualization API is loaded.
google.charts.setOnLoadCallback(setupTable);

var data, table;
var setupDone = false;

var ws = new WebSocket('ws://localhost:1234');

ws.onopen = function(){
    console.log("Connected!!");
    document.getElementById('deleteButton').onclick = clearTable;
    
};

ws.onerror = function(){
    console.log("Error: " + error);
};

ws.addEventListener('message', function(e){
    if(e.data == "Connected"){
        document.getElementById('connectionStatus').innerHTML = e.data;
    }else{
       var msg = e.data;
        console.log(msg);
        var dataString = msg.toString("ascii").trim();
        var values = dataString.split("|");



        var date = new Date();
        var time = values[0].split(":");
        date.setHours(time[0]);
        date.setMinutes(time[1]);
        date.setSeconds(time[2]);

        if(values[1] == "OPEN"){
            document.getElementById('status').style.color = "green";
        }else if(values[1] == "CLOSED"){
            document.getElementById('status').style.color = "red";
        }
        document.getElementById('status').innerHTML = values[1];
        document.getElementById('time').innerHTML = date;
        document.getElementById('battery').innerHTML = values[2] + "% Battery";

        updateTable(values[1], date, parseInt(values[2])); 
    }
});

function updateTable(state, time, battery){
    if(setupDone){       
        data.addRow([state,time, battery]);
        table.draw(data, {'sortAscending': false, 'sortColumn':1});
        localStorage.data = data.toJSON();
    }  
}

function setupTable(){
    table = new google.visualization.Table(document.getElementById('table_div'));

    if(localStorage.data != null){
        data = new google.visualization.DataTable(localStorage.data);
        table.draw(data, {'sortAscending': false, 'sortColumn':1});
        
        if(data.getValue(0,0) == "OPEN"){
            document.getElementById('status').style.color = "green";
        }else if(data.getValue(0,0) == "CLOSED"){
            document.getElementById('status').style.color = "red";
        }
        document.getElementById('status').innerHTML = data.getValue(0,0);
        document.getElementById('time').innerHTML = data.getValue(0,1);
        document.getElementById('battery').innerHTML = data.getValue(0,2) + "% Battery";
        
    }else{
        data = new google.visualization.DataTable();
        data.addColumn('string', 'State');
        data.addColumn('datetime', 'Time');
        data.addColumn('number', 'Battery %');
   }
    
        
    setupDone = true;
}

function clearTable(){
    console.log('clear table');
    if(setupDone){ 
        for (var i = data.getNumberOfRows()-2; i >=0; i--){
            data.removeRow(i);
        }
        table.draw(data, {'sortAscending': false, 'sortColumn':1});
    }
}

